<?php
#-----------------------------------------------------------------------
# settings:  adapted for Saratoga ####### Saratoga
#-----------------------------------------------------------------------
$bl_api_key     = 'xuevrt_etLTRos6iv3C76dQ=';   // obtained from your bloomsky dashboard => click "Developers" at the left bottom
#
$bl_intl_units  = true;         // for non-us display of data
$bl_intl_units  = false;       // remove # when using imperial units
#
$bl_lang        = $SITE['lang']; #### Saratoga "en";         // en de fr nl  includedlang  
                                // You find the translations at the end of the script
                                // last one is for an extra language
#
$bl_timezone    = false;        // set outside the script
$bl_timezone    = $SITE['tz']; ##Saratoga   'America/New_York';   // remove the comment mark to use your own time zone and set a valid timezone
#
$bl_debug       = true;         // to get some debug info when first using this script
#bl_debug        = false;       // remove # when finished testing
#
$bl_charset     = $SITE['charset'];### Saratoga 'UTF-8';      // most used character set nowadays
#
#$bl_date_time   = "d-m-Y H:i T";  // for metric / europe
#$bl_date_time   = "M j Y g:ia T"; // remove # when using US date time format
#                               // you can remove the T (=timezone string) when date and times are correctly displayed
#
$bl_date_time   = $SITE['timeFormat']; ####### Saratoga
#
$bl_header      = '';           // leave blank and the description from your Bloomsky setup is used.
#$bl_header      = 'your-own_description';  // remove comment mark en change to your own text if needed
#
$bl_technical   = true;         // show update time and other non weather info
#$bl_technical   = false;       // show weather info only
#
$bl_font_CSS    = '';           // default the font settings from the enclosing script or from your webser init settings are used
$bl_font_CSS    = 'font-family: Arial, Helvetica, sans-serif; ';       // or you can set the font to be used here, and remove comment mark
#
$bl_div_CSS     = 'border-radius: 5px;  margin: 0px;  color: black;  background-color: transparent; border: 1px solid grey; border-bottom: 3px solid grey;';
$bl_head_CSS    = 'font-weight: bold; color: white; background-color: #7190BF; text-align: center; margin: 0;';
$bl_button_sel  = "grey";
#
$bl_included    = true;         // include this script and use your own enclosing html head and body and so on
#$bl_included    = false;       // run as a full page without your own html css and so on
#
#-----------        KNOWN problems -------------------------------------
$bl_https       = 'https';
#$bl_https       = 'http';     // only remove the comment mark when your webserver does not want to connect properly
#
$bl_skip_verify = false;        // some servers return error which the script display as
#        SSL certificate problem: unable to get local issuer certificate 
#$bl_skip_verify = true;        // remove comment mark to add some extra lines to MAYBE overcome this
#
# END OF settings: do not change below this line if you do not know why you are doing it
#-----------------------------------------------------------------------
#
if (isset($_REQUEST['sce']) && strtolower($_REQUEST['sce']) == 'view' ) {
        $filenameReal = __FILE__;			# display source of script if requested so
        $download_size = filesize($filenameReal);
        header('Pragma: public');
        header('Cache-Control: private');
        header('Cache-Control: no-cache, must-revalidate');
        header("Content-type: text/plain");
        header("Accept-Ranges: bytes");
        header("Content-Length: $download_size");
        header('Connection: close');
        readfile($filenameReal);
        exit;
}
$pageName	= 'ws_bloomsky.php';    // normal; horizontal version 
$pageVersion	= '1.00 2016-02-29';   
#-----------------------------------------------------------------------
# 1.00 2016-02-29  first version	
# ----------------------------------------------------------------------
$SITE['wsModules'][$pageName] = 'version: ' . $pageVersion;
$pageFile = basename(__FILE__);			// check to see this is the real script
if ($pageFile <> $pageName) {$SITE['wsModules'][$pageFile]	= 'this file loaded instead of '.$pageName;}
if (!isset ($bl_debug) && $bl_debug == true) {
        echo '<!-- module '.$pageFile.' ==== '.$SITE['wsModules'][$pageFile]." -->".PHP_EOL;
}
#-----------------------------------------------------------------------
#
if (isset($_REQUEST['apikey'])  && trim($_REQUEST['apikey']) <> '') {
        $bl_api_key     = trim($_REQUEST['apikey']);
}
if (isset($_REQUEST['lang'])    && trim($_REQUEST['lang']) <> '') {
        $bl_lang        = trim($_REQUEST['lang']);
}
#
# check / default all settings
#
if (!isset ($bl_intl_units) )   {  $bl_intl_units       = false; }
if (!isset ($bl_debug) )        {  $bl_debug            = false; } 
if (!isset ($bl_silent) )       {  $bl_silent           = false; } 
if (!isset ($bl_lang) )         {  $bl_lang             = 'en'; } 
if (!isset ($bl_charset) )      {  $bl_charset          = 'UTF-8'; } 
if (!isset ($bl_https) )        {  $bl_https            = 'https'; }
if (isset ($lang) && strlen(trim($lang)) == 2) { $bl_lang = trim($lang); }
#
if (isset ($bl_timezone)  &&  $bl_timezone <> false &&  $bl_timezone <> '') { 
        if (!function_exists('date_default_timezone_set')) {
                 putenv("TZ=" . $bl_timezone);
        } else {
                 date_default_timezone_set($bl_timezone);
        }
}
#
$link   = $bl_https.'://api.bloomsky.com/api/skydata/';
if ($bl_intl_units)             { 
        $link   .= '?unit=intl';
}
$header         = array('Authorization:'.$bl_api_key);
#
# Now do a CURL to retrieve the  information
#
$curl_errors    = array();
$curl_info	= array();
#
$ch = curl_init();
curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt ($ch, CURLOPT_URL, $link);
curl_setopt ($ch, CURLOPT_FILETIME, 1);
curl_setopt ($ch, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
curl_setopt ($ch, CURLOPT_TIMEOUT, 10);
curl_setopt ($ch, CURLOPT_HTTPHEADER, $header );
if (isset ($bl_skip_verify)  && $bl_skip_verify == true) {
        curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);
}
$rawData = curl_exec ($ch);

$curl_info	= curl_getinfo($ch);
$curl_errors    = curl_error($ch);
#
curl_close ($ch);

unset ($ch);
#
$bl_data_error  = 0;
$bl_error_text  = '';
#
if (strlen($rawData) < 2) {     // no data retrieved
        $bl_data_error  = 1;    // invalid data
}
if (!is_array($curl_errors)) {
        if (trim($curl_errors) <> '') {
                $bl_data_error  = 2;    // invalid error information
                $bl_error_text  .= 'Unknown single error occured: info =('.$curl_errors.')<br />'.PHP_EOL;
        }
}
elseif (count ($curl_errors) > 0 ) {
        $bl_error_text  .= 'Multiple errors occured:<br />'.PHP_EOL;
        $bl_data_error  = 3;    // some data error 
        for ($n = 0; $n < count ($curl_errors); $n++) {
                $nr     = $n +1;
                $bl_error_text  .= '('.$nr.')&nbsp;'.$bl_data_error.'<br />'.PHP_EOL;
        }
}
if (strpos ($rawData, 'does not exist') > 0) {
        $bl_data_error  = 4;    // invalid error information
        $bl_error_text  .= 'INVALID API KEY'.PHP_EOL;
}
$arr_j  = json_decode($rawData, true);  
if ( $arr_j == NULL) {
        $bl_data_error  = 5;    // invalid json data  error 
        $bl_error_text  .= 'Unknown (non-json) data =('.substr($rawData,0,40).') first 40 charecters of returned data only<br />'.PHP_EOL;
}
if ($bl_data_error <> 0 ) {
        if ( $bl_silent <> true ) {
                echo 'Data retrieved: ('. substr($rawData,0,100).')<br />'.PHP_EOL;
                echo 'Errors occured:<br />'.$bl_error_text;
        }
        return false;
}
unset ($rawData);       
# debug only echo '<pre>Decode json ='.print_r($arr_j,true).'</pre>'.PHP_EOL;# exit;
$arr    = $arr_j[0];            // data is array but there is only one item present
if (!isset ($bl_address_full) ||  $bl_address_full == '') {                  
        $bl_address_full        = $arr['FullAddress'];
}
if (!isset ($bl_address_short) ||  $bl_address_short == '') {                  
        $bl_address_short       = $arr['CityName'].' - '.$arr['StreetName'];
}
if (trim($bl_header) == '') {
        if ( trim($bl_address_short <> '') ) {
                $bl_header = $bl_address_short;
        }
        else {  $bl_header = $bl_address_full;
        }
}
# check if image is recent
$now            = time();
$bl_max_age     = $now - 24*3600;
#
$bl_data        = $arr['Data'];
$arr_bl_lang    = bl_load_lang($bl_lang);
$bl_uoms        = bl_load_uoms($bl_intl_units);
$bl_img         = $bl_data['ImageURL'];
$bl_img_time    = $bl_data['ImageTS'];
$bl_img_age     = $now - $bl_img_time;
if ($bl_img_time < $bl_max_age) {$bl_to_old   = true;} else {$bl_to_old   = false;}
$bl_last_data   = date($bl_date_time,$bl_data['TS']);
#
$count          = count ($arr['VideoList']);
$n              = $count - 1;
$video          = $arr['VideoList'][$n];
if ($bl_data['Rain'])   {$bl_data['Rain']       = $arr_bl_lang['true'];}        else    {$bl_data['Rain']       = $arr_bl_lang['false'];}
if ($bl_data['Night'])  {$bl_data['Night']      = $arr_bl_lang['night_yes'];}   else    {$bl_data['Night']      = $arr_bl_lang['false'];}
if ($bl_intl_units)     {$bl_data['Pressure']   = round($bl_data['Pressure'],0);} else  {$bl_data['Pressure']   = round($bl_data['Pressure'],2);}
#
if (!isset ($bl_div_CSS)  )    { $bl_div_CSS   = 'border-radius: 5px;  margin: 5px 5px;  color: black;  background-color: transparent; border: 1px solid grey; border-bottom: 3px solid grey;'; }
if (!isset ($bl_head_CSS)  )   { $bl_head_CSS  = 'font-weight: bold; color: white; background-color: grey; text-align: center; margin: 0;';}
if (!isset ($bl_font_CSS)  )   { $bl_font_CSS   = ''; }
#-----------------------------------------------------------------------
# Some enclosing html if you run stand alone = without including in your own page
#
if (isset ($bl_included) && $bl_included  <> true) {
        $bl_html0 = '<html lang='.$bl_lang.'>
<head>
<meta content="yes" name="apple-mobile-web-app-capable" />
<meta content="text/html; charset='.$bl_charset.'" http-equiv="Content-Type" />

</head>
<body>';
        $bl_html99 = '
</body>
</html>'.PHP_EOL;
} 
else {  $bl_html0 = $bl_html99 = '';
}
#-----------------------------------------------------------------------
$bl_html1 = '<div class="blockDiv">
<style scoped>
        table           {margin: 0 auto; vertical-align: top;}
        .bl_desc        {text-align: right;}
        .bl_value       {text-align: left;}
        .bl_image       {vertical-align: top; width: 30%;}
        .bl_image img   {max-width: 641px; vertical-align: top;}
        .bl_image video {max-width: 641px; vertical-align: top;}
        .bl_values      {width: 350px; margin: 10px; vertical-align: top;}
        .blockDiv       {'.$bl_font_CSS.$bl_div_CSS.'}
        .blockHead      {'.$bl_head_CSS.'}
</style>
<h4 class="blockHead">'.$arr_bl_lang['my_page'].$bl_header.'</h4>
<table>
<tr>
<td class="bl_image"><img   src="'.$bl_img.'" style="width: 100%;"/><br /><br />&nbsp;</td>
<td class="bl_values">
<table>
        <tr><td class="bl_desc">'.$arr_bl_lang['Temperature'].':&nbsp;</td><td class="bl_value">'.round($bl_data['Temperature'],1).$bl_uoms['Temperature'].'</td></tr>
        <tr><td class="bl_desc">'.$arr_bl_lang['Humidity'].':&nbsp;</td><td class="bl_value">'.$bl_data['Humidity'].$bl_uoms['Humidity'].'</td></tr>
        <tr><td class="bl_desc">'.$arr_bl_lang['Pressure'].':&nbsp;</td><td class="bl_value">'.$bl_data['Pressure'].$bl_uoms['Pressure'].'</td></tr>
        <tr><td class="bl_desc">'.$arr_bl_lang['Rain'].':&nbsp;</td><td class="bl_value">'.$bl_data['Rain'].$bl_uoms['Rain'].'</td></tr>
        <tr><td class="bl_desc">'.$arr_bl_lang['UVIndex'].':&nbsp;</td><td class="bl_value">'.$bl_data['UVIndex'].$bl_uoms['UVIndex'].'</td></tr>
        <tr><td class="bl_desc">'.$arr_bl_lang['Luminance'].':&nbsp;</td><td class="bl_value">'.$bl_data['Luminance'].$bl_uoms['Luminance'].'</td></tr>
        <tr><td class="bl_desc">'.$arr_bl_lang['Voltage'].':&nbsp;</td><td class="bl_value">'.$bl_data['Voltage'].$bl_uoms['Voltage'].'</td></tr>
        <tr><td class="bl_desc">'.$arr_bl_lang['Night'].':&nbsp;</td><td class="bl_value">'.$bl_data['Night'].$bl_uoms['Night'].'</td></tr>';
if ($bl_technical) {
    if ($bl_to_old) {$bl_html1 .= '
        <tr><td class="bl_desc">'.$arr_bl_lang['From'].':&nbsp;</td><td class="bl_value">'.date($bl_date_time,$bl_data['ImageTS']).'</td></tr>';
    }
    $bl_html1 .= '        
        <tr><td class="bl_desc">'.$arr_bl_lang['LastData'].':&nbsp;</td><td class="bl_value">'.$bl_last_data.'</td></tr>';
}
$bl_html1 .= '        
</tr>
</table>
</td> 
<td class="bl_image">
<video  id="bl_video" style="width: 100%;" controls>
  <source id="bl_mp4_src" src="'.$video.'" type="video/mp4">
Your browser does not support the video tag.
</video>
<table><tr>
<td class="wl_button">
        <button id="bl_btn_0"      onclick="bl_select(0)"       type="button" style="background-color: '.$bl_button_sel.';">'.$arr_bl_lang['Last'].'</button>';
for ($n = 1; $n < $count; $n++) {
        $bl_html1 .= '
        <button id="bl_btn_'.$n.'" onclick="bl_select('.$n.')" type="button" style="background-color: transparent;">-'.$n.'</button>'; 
}
$bl_html1 .= '
</td>
</tr></table>
</td>
</tr></table>
<script> 
function bl_select($nr) {
        var movie       = new Array();
        var pnt         = $nr;
        movie[0]="'.$arr['VideoList'][4].'"
        movie[1]="'.$arr['VideoList'][3].'"
        movie[2]="'.$arr['VideoList'][2].'"
        movie[3]="'.$arr['VideoList'][1].'"
        movie[4]="'.$arr['VideoList'][0].'"
        document.getElementById("bl_mp4_src").src = movie[pnt];
        document.getElementById("bl_video").load();
        document.getElementById("bl_btn_0").style.backgroundColor="transparent";
        document.getElementById("bl_btn_1").style.backgroundColor="transparent";
        document.getElementById("bl_btn_2").style.backgroundColor="transparent";
        document.getElementById("bl_btn_3").style.backgroundColor="transparent";
        document.getElementById("bl_btn_4").style.backgroundColor="transparent";
        var button = "bl_btn_"+pnt;
        document.getElementById(button).style.backgroundColor="'.$bl_button_sel.'";
        document.getElementById("bl_video").play();
} 
</script>
</div> '.PHP_EOL; 
#
echo $bl_html0.$bl_html1.$bl_html99;
#
function bl_load_lang($lang) {
    global $bl_charset;
    if     ($lang == 'en') {
# ---------------------------------------------- English  texts --------
        $arr_bl_lang['Temperature']     = 'Temperature';# C / F
        $arr_bl_lang['Humidity']        = 'Humidity';   # %
        $arr_bl_lang['Pressure']        = 'Pressure';   # mbar
        $arr_bl_lang['Rain']            = 'Is it raining?'; # yes no
        $arr_bl_lang['Luminance']       = 'Luminance';  #  cd/m2,
        $arr_bl_lang['UVIndex']         = 'UVIndex';    # -
        $arr_bl_lang['Night']           = 'Is it nighttime?';    # -
        $arr_bl_lang['Voltage']         = 'Voltage';    # mv
        $arr_bl_lang['true']            = 'Yes';        
        $arr_bl_lang['false']           = 'No';   
        $arr_bl_lang['night_yes']       = 'Yes, Left image is not recent'; 
        $arr_bl_lang['my_page']         = 'Our Bloomsky weather device at ';
        $arr_bl_lang['LastData']        = 'Last data uploaded at'; 
        $arr_bl_lang['From']            = 'Image date/time';
        $arr_bl_lang['Last']            = 'Last movie';
        $arr_bl_lang['Image']           = 'Image';                  
# --------------------------------- English  texts ------ END OF -------
    }
    elseif ($lang == 'fr') {
# ----------------------------------------- French / Français texts ----
        $arr_bl_lang['Temperature']     = 'Température';
        $arr_bl_lang['Humidity']        = 'Humidité';
        $arr_bl_lang['Pressure']        = 'Pression baro';
        $arr_bl_lang['Rain']            = 'Il pleut?';
        $arr_bl_lang['Luminance']       = 'Luminance';
        $arr_bl_lang['UVIndex']         = "L'indice UV";
        $arr_bl_lang['Night']           = 'Est-il la nuit?';
        $arr_bl_lang['Voltage']         = 'Voltage';
        $arr_bl_lang['true']            = 'Oui';        
        $arr_bl_lang['false']           = 'Non';   
        $arr_bl_lang['night_yes']       = 'Oui, Image de gauche est pas récente';    
        $arr_bl_lang['my_page']         = 'Notre appareil météo Bloomsky à ';           
        $arr_bl_lang['LastData']        = 'Dernières données téléchargées à ';
        $arr_bl_lang['From']            = "Date et heure de l'image ";   
        $arr_bl_lang['Last']            = 'Dernier film';
        $arr_bl_lang['Image']           = 'Image';                  
# --------------------- French / Français texts --------- END OF -------
    }
    elseif ($lang == 'nl') {
# -------------------------------- Nederlands / Dutch texts-------------
        $arr_bl_lang['Temperature']     = 'Temperatuur';# C / F
        $arr_bl_lang['Humidity']        = 'Luchtvochtigheid';   # %
        $arr_bl_lang['Pressure']        = 'Luchtdruk';   # mbar
        $arr_bl_lang['Rain']            = 'Regent het?'; # yes no
        $arr_bl_lang['Luminance']       = 'Lichtwaarde';  #  cd/m2,
        $arr_bl_lang['UVIndex']         = 'UV-index';    # -
        $arr_bl_lang['Night']           = 'Is het donker?';    # -
        $arr_bl_lang['Voltage']         = 'Voltage';    # mv
        $arr_bl_lang['true']            = 'Ja';        
        $arr_bl_lang['false']           = 'Nee';   
        $arr_bl_lang['night_yes']       = 'Ja, Plaatje links is niet recent'; 
        $arr_bl_lang['my_page']         = 'Demo van onze Bloomsky weeercamera in '; 
        $arr_bl_lang['LastData']        = 'Bijgewerkt om'; 
        $arr_bl_lang['From']            = 'Afbeelding van';                
        $arr_bl_lang['Last']            = 'Laaste film';
        $arr_bl_lang['Image']           = 'Foto';                  
# ---------------------- Nederlands / Dutch texts ------- END OF -------
    }
    elseif ($lang == 'de') {
# ----------------------------------------- German / Deutsche texts ----
        $arr_bl_lang['Temperature']     = 'Temperatur';
        $arr_bl_lang['Humidity']        = 'Feuchtigkeit'; 
        $arr_bl_lang['Pressure']        = 'Luftdruck';
        $arr_bl_lang['Rain']            = 'Regnet es?';
        $arr_bl_lang['Luminance']       = 'Leuchtdichte';
        $arr_bl_lang['UVIndex']         = 'UV-Index';    # -
        $arr_bl_lang['Night']           = 'Ist es Nacht?';    # -
        $arr_bl_lang['Voltage']         = 'Stromspannung';    # mv
        $arr_bl_lang['true']            = 'Ja';        
        $arr_bl_lang['false']           = 'Nein';   
        $arr_bl_lang['night_yes']       = 'Ja, Bild links ist nicht aktuell'; 
        $arr_bl_lang['my_page']         = 'Unsere Bloomsky Wetter Gerät an ';
        $arr_bl_lang['LastData']        = 'Letzte Daten hochgeladen am'; 
        $arr_bl_lang['From']            = 'Bild Datum / Zeit';                
        $arr_bl_lang['Last']            = 'Letzter Film';
        $arr_bl_lang['Image']           = 'Bild';                  
# -------------------------German / Deutsche texts ---- END OF ---------
    }
    else {
# ----------------------------------------- New  / unknown texts -------
        $arr_bl_lang['Temperature']     = 'Temperature';# C / F
        $arr_bl_lang['Humidity']        = 'Humidity';   # %
        $arr_bl_lang['Pressure']        = 'Pressure';   # mbar
        $arr_bl_lang['Rain']            = 'Is it raining?'; # yes no
        $arr_bl_lang['Luminance']       = 'Luminance';  #  cd/m2,
        $arr_bl_lang['UVIndex']         = 'UVIndex';    # -
        $arr_bl_lang['Night']           = 'Is it nighttime?';    # -
        $arr_bl_lang['Voltage']         = 'Voltage';    # mv
        $arr_bl_lang['true']            = 'Yes';        
        $arr_bl_lang['false']           = 'No';   
        $arr_bl_lang['night_yes']       = 'Yes, Left image is not recent'; 
        $arr_bl_lang['my_page']         = 'Demo of our Bloomsky weather device at ';
        $arr_bl_lang['LastData']        = 'Last data uploaded at'; 
        $arr_bl_lang['From']            = 'Image date/time';                 
        $arr_bl_lang['Last']            = 'Last movie';
        $arr_bl_lang['Image']           = 'Image';                                    
# --------------------- New  / unknown texts ------------ END OF -------
    }
#
    if ($bl_charset <> 'UTF-8') {
        foreach ($arr_bl_lang as $key => $translation) { 
                $translation            = iconv('UTF-8', $bl_charset, $translation);
                $arr_bl_lang[$key]      = $translation;
        }  // end foreach entry in translation array              
    } // eo not utf-8
    return $arr_bl_lang;
} // eof bl_load_lang
function bl_load_uoms($bl_intl_units) {
        $bl_uoms['Rain']        = '';
        $bl_uoms['UVIndex']     = '';
        $bl_uoms['Night']       = '';    # -
        $bl_uoms['true']        = '';        
        $bl_uoms['false']       = ''; 
        if ($bl_intl_units) {
                $bl_uoms['Temperature'] = '&deg;C';
                $bl_uoms['Pressure']    = '&nbsp;mbar';
        } else {
                $bl_uoms['Temperature'] = '&deg;F';
                $bl_uoms['Pressure']    = '&nbsp;inhg'; 
        }
        $bl_uoms['Humidity']    = '&nbsp;%';   
        $bl_uoms['Luminance']   = '&nbsp;cd/m2';
        $bl_uoms['Voltage']     = '&nbsp;mv';
        return $bl_uoms;
}